/* Copyright (C) 2011 Chris Moeller, Brad Miller
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 2.1 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __BASSDRIVER_H__
#define __BASSDRIVER_H__

#include "bass.h"
#include "bassmidi.h"
#include <windows.h>
#include <stdio.h>
#include <tchar.h>

class BASSDriver {
private:
	BYTE gs_part_to_ch[16];
	BYTE drum_channels[16];
	unsigned int font_count;
	HSOUNDFONT * hFonts;
	HSTREAM hStream;
	void load_settings();
	void FreeFonts();
	void LoadFonts(const TCHAR * name);
public:
	BASSDriver();
	~BASSDriver();
	void ResetDrumChannels();
	void CloseBASSDriver();
	BOOL OpenBASSDriver();
	void ProcessMIDIMessage(DWORD dwParam1);
	void ProcessSysEx(unsigned char *sysexbuffer,int exlen);
	void Render(short * samples, int len);
};

#endif