!include "x64.nsh"
!include MUI2.nsh
!include WinVer.nsh
; The name of the installer
Name "BASSMIDI System Synth"

; The file to write
OutFile "bassmididrv.exe"
; Request application privileges for Windows Vista
RequestExecutionLevel admin
SetCompressor /solid lzma 
;--------------------------------
; Pages
!insertmacro MUI_PAGE_WELCOME
Page Custom LockedListShow
!insertmacro MUI_PAGE_INSTFILES
UninstPage Custom un.LockedListShow
!insertmacro MUI_UNPAGE_CONFIRM
!insertmacro MUI_UNPAGE_INSTFILES
!insertmacro MUI_LANGUAGE "English"

!macro DeleteOnReboot Path
  IfFileExists `${Path}` 0 +3
    SetFileAttributes `${Path}` NORMAL
    Delete /rebootok `${Path}`
!macroend
!define DeleteOnReboot `!insertmacro DeleteOnReboot`

Function LockedListShow
 ${If} ${AtLeastWinVista}
  !insertmacro MUI_HEADER_TEXT `File in use check` `Drive use check`
  LockedList::AddModule \bassmididrv.dll
  LockedList::Dialog 
  Pop $R0
  ${EndIf}
FunctionEnd
Function un.LockedListShow
 ${If} ${AtLeastWinVista}
  !insertmacro MUI_HEADER_TEXT `File in use check` `Drive use check`
  LockedList::AddModule \bassmididrv.dll
  LockedList::Dialog 
  Pop $R0
 ${EndIf}
FunctionEnd
;--------------------------------
Function .onInit
   MessageBox MB_YESNO "This will install the BASSMIDI System Synth. Continue?" IDYES NoAbort
     Abort ; causes installer to quit.
   NoAbort:
 FunctionEnd
; The stuff to install
Section "Needed (required)"
  SectionIn RO
  ; Copy files according to whether its x64 or not.
   DetailPrint "Copying driver and synth..."
   ${If} ${RunningX64}
   SetOutPath $WINDIR\SysWow64
   File bass.dll 
   File bassmidi.dll 
   File bassmididrv.dll 
   File bassmididrvcfg.exe
   RegDLL "$WINDIR\SysWow64\bassmididrv.dll"
   ${Else}
   SetOutPath $WINDIR\System32
   File bass.dll 
   File bassmidi.dll 
   File bassmididrv.dll 
   File bassmididrvcfg.exe
   RegDLL "$WINDIR\System32\bassmididrv.dll"
   ${EndIf}
    ;Set the MIDI driver key (ICK!)
  ReadRegStr $0  HKLM "Software\Microsoft\Windows NT\CurrentVersion\Drivers32" "midi1"
  WriteRegStr HKLM "Software\Microsoft\Windows NT\CurrentVersion\Drivers32" "midi1" "bassmididrv.dll"
  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\BASSMIDI System Synth\Backup" \
  "MIDI" "$0"
  ; Write the uninstall keys
  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\BASSMIDI System Synth" "DisplayName" "BASSMIDI System Synth"
  WriteRegDWORD HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\BASSMIDI System Synth" "NoModify" 1
  WriteRegDWORD HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\BASSMIDI System Synth" "NoRepair" 1
  WriteRegDWORD HKCU "Software\BASSMIDI Driver" "volume" "10000"
  CreateDirectory "$SMPROGRAMS\BASSMIDI System Synth"
 ${If} ${RunningX64}
   WriteUninstaller "$WINDIR\SysWow64\bassmididrvuninstall.exe"
   WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\BASSMIDI System Synth" "UninstallString" '"$WINDIR\SysWow64\bassmididrvuninstall.exe"'
   CreateShortCut "$SMPROGRAMS\BASSMIDI System Synth\Uninstall.lnk" "$WINDIR\SysWow64\bassmididrvuninstall.exe" "" "$WINDIR\SysWow64\bassmididrvuninstall.exe" 0
   CreateShortCut "$SMPROGRAMS\BASSMIDI System Synth\Configure Driver.lnk" "$WINDIR\SysWow64\bassmididrvcfg.exe" "" "$WINDIR\SysWow64\bassmididrvcfg.exe" 0
   ${Else}
   WriteUninstaller "$WINDIR\System32\bassmididrvuninstall.exe"
   WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\BASSMIDI System Synth" "UninstallString" '"$WINDIR\System32\bassmididrvuninstall.exe"'
   CreateShortCut "$SMPROGRAMS\BASSMIDI System Synth\Uninstall.lnk" "$WINDIR\System32\bassmididrvuninstall.exe" "" "$WINDIR\System32\bassmididrvuninstall.exe" 0
   CreateShortCut "$SMPROGRAMS\BASSMIDI System Synth\Configure Driver.lnk" "$WINDIR\System32\bassmididrvcfg.exe" "" "$WINDIR\System32\bassmididrvcfg.exe" 0
   ${EndIf}
   MessageBox MB_OK "Installation complete! Use the driver configuration tool which is in the 'BASSMIDI System Synth' program shortcut directory to configure the driver."

SectionEnd
;--------------------------------

; Uninstaller

Section "Uninstall"
   ; Remove registry keys
  ReadRegStr $0 HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\BASSMIDI System Synth\Backup" \
       "MIDI"
  DeleteRegValue HKLM "Software\Microsoft\Windows NT\CurrentVersion\Drivers32" $0
  DeleteRegKey HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\BASSMIDI System Synth"
  DeleteRegKey HKCU "Software\BASSMIDI Driver"
  RMDir /r "$SMPROGRAMS\BASSMIDI System Synth"

 ${If} ${RunningX64}
 ${If} ${AtLeastWinVista}
  UnRegDLL "$WINDIR\SysWow64\bassmididrv.dll"
  Delete $WINDIR\SysWow64\bass.dll
  Delete $WINDIR\SysWow64\bassmidi.dll
  Delete $WINDIR\SysWow64\bassmididrv.dll
  Delete $WINDIR\SysWow64\bassmididrvuninstall.exe
  Delete $WINDIR\SysWow64\bassmididrvcfg.exe
${Else}
  UnRegDLL "$WINDIR\SysWow64\bassmididrv.dll"
  MessageBox MB_OK "Note: The uninstaller will reboot your system to remove drivers."
  ${DeleteOnReboot} $WINDIR\SysWow64\bass.dll
  ${DeleteOnReboot} $WINDIR\SysWow64\bassmidi.dll
  ${DeleteOnReboot} $WINDIR\SysWow64\bassmididrv.dll
  ${DeleteOnReboot} $WINDIR\SysWow64\bassmididrvuninstall.exe
  ${DeleteOnReboot} $WINDIR\SysWow64\bassmididrvcfg.exe
  Reboot
${Endif}
${Else}
${If} ${AtLeastWinVista}
  UnRegDLL "$WINDIR\System32\bassmididrv.dll"
  Delete $WINDIR\System32\bass.dll
  Delete $WINDIR\System32\bassmidi.dll
  Delete $WINDIR\System32\bassmididrv.dll
  Delete $WINDIR\System32\bassmididrvuninstall.exe
  Delete $WINDIR\System32\bassmididrvcfg.exe
${Else}
  UnRegDLL "$WINDIR\System32\bassmididrv.dll"
  MessageBox MB_OK "Note: The uninstaller will reboot your system to remove drivers."
  ${DeleteOnReboot} $WINDIR\System32\bass.dll
  ${DeleteOnReboot} $WINDIR\System32\bassmidi.dll
  ${DeleteOnReboot} $WINDIR\System32\bassmididrv.dll
  ${DeleteOnReboot} $WINDIR\System32\bassmididrvuninstall.exe
  ${DeleteOnReboot} $WINDIR\System32\bassmididrvcfg.exe
  ${DeleteOnReboot} $WINDIR\System32\bassmididrv.ini
  Reboot
${Endif}
${EndIf}
SectionEnd
